// C Source File
// Created 27/07/2003; 12:00:35

#include "mkcomplib.h"

/*===============================================================================================
== Give all the information of a compressed variable
=================================================================================================
== data : pointer to the compressed data
=================================================================================================
== return the InfosComp structure of the var : if the var is not compressed, it return the
informations of the var
===============================================================================================*/
InfosComp GetInfosComp(unsigned char * data) {
  InfosComp infoscomp;
  
  unsigned char type;
  
  infoscomp.comp=COMP_TYPE_NORMAL;
  infoscomp.size=*(unsigned short *)data;
  type=data[infoscomp.size+1];
  infoscomp.var=type;

  if (type==OTH_TAG) {  //peut-etre un zip
    if (strcmp(&(data[infoscomp.size-4]),"KOMP")==0 && data[5]<3) {
      infoscomp.var=data[4];
      infoscomp.comp=COMP_TYPE_KOMP;
      infoscomp.size=((unsigned short *)data)[1];
    } else if (strcmp(&(data[infoscomp.size-3]),"ZIP")==0 && data[3]==0xFF) {
      infoscomp.var=conv_type_filelib_TIOS[data[2]];
      infoscomp.comp=COMP_TYPE_ZIPLIB;
      infoscomp.size=((unsigned short *)data)[6];
    } else if (strcmp(&(data[infoscomp.size-4]),"LZFO")==0) {
      infoscomp.var=data[4];
      infoscomp.comp=COMP_TYPE_LZFO;
      infoscomp.size=((unsigned short *)data)[1];
    }
  }
  return infoscomp;
}
