// C Source File
// Created 27/07/2003; 12:23:24

#include "mkcomplib.h"

/*===============================================================================================
== Generic functions which (de)compress every files in a folder
=================================================================================================
== name_fold : name of the folder
== fct_comp : function of compression or decompression to use on the files : you have to use the
hsym functions
== draw_message : the function which draw the message. It can be NULL, and the sensibility of
drawing message is defined by the parameter draw
== draw_progress_global : function that will will show the evolution of the action on the entire
folder. In fact, is count the files. It can be NULL.
== draw_progress_local : function that will show tghe progress of the compression of each file. It
can be NULL
== draw : the priority of drawing the messages: see DRAW defines
===============================================================================================*/

CompErr * WorkOnFolderGB(const unsigned char * name_folder, FctComplib_comp fct_comp, FctComplib_draw_message draw_message, char draw) {
  
  SYM_ENTRY * SymPtr;
  HSym hsym;
  unsigned char name[18];
  CompErr pb;
  short time=0;
  short total;
  CompErr * errors;

  total=FolderCount(DerefSym(SymFind(SYMSTR(name_folder))));

  if (total==0)
    return NULL;

  errors = malloc(total*sizeof(char));

  SymPtr=SymFindFirst(SYMSTR(name_folder),FO_SINGLE_FOLDER);
  
  while (SymPtr!=NULL) {
    sprintf(name,"%s\\%s",name_folder,SymPtr->name);
    hsym=SymFind(SYMSTR(name));
    fct_comp(hsym,NULL,&pb);
    errors[time]=pb;
    if (draw_message!=NULL)
      DrawCompErrorGB(pb,draw_message,draw);
    SymPtr=SymFindNext();
  }
  return errors;    
}
