// C Source File
// Created 27/07/2003; 11:56:32

#include "mkcomplib.h"

/*===============================================================================================
== Ziplib compression of datas in a variable
=================================================================================================
== data : pointer of the datas to compress
== length : length of the datas to compress
== name_var_dest : name of the variable where the compressed datas will be stored
== str_tag : a string which contain the tag to add atthe end of the file. For exemple :
'\0','E','X','T','\O',OTH_TAG
== tag_length : length of the tag (the tag doesn't finish by '\0' ! impossible to use strlen !)
== error : pointer to return the error code
=================================================================================================
== return the hsym structure created, else HS_NULL
===============================================================================================*/

HSym zip_data_hsym(unsigned char * data, unsigned short length, const unsigned char * name_var,  CompErr * error) {

  TREE * tree=NULL;
  short          nL;
  unsigned short comp_len;
  short          offset;

  HANDLE h;
  unsigned char * dest;
  
  *error=study_zip(data,length,&tree,&nL,&comp_len,&offset,FALSE);

  if (*error!=COMP_NO_ERR)
    return HS_NULL;  
  
  h=HeapAlloc(comp_len+2);
  if (h==H_NULL) {
    free(tree);
    *error=COMP_ERR_MEM;
    return HS_NULL;
  }
  dest=HLock(h);
  
  *error=mk_zip(data,length,dest,tree,nL,comp_len,offset,15,FALSE);
  
  if (*error!=COMP_NO_ERR) {
  	HeapFree(h);
  	return HS_NULL;
  }
  
  HeapUnlock(h);

  return mk_var(HS_NULL,name_var,h,error);
}
