
#include "mkcomplib.h"

/*===============================================================================================
== Ziplib compresion
=================================================================================================
== data : data to compress
== length : length of data to compress
== type : filelib type of the data
== temp : boolean false if we create a TI-OS variable (add the "ZIP" tag)
                  true if it's temporary
== error : pointer to return the error code
=================================================================================================
== return the handle of the compressed datas
===============================================================================================*/

CompErr zip_hsym(HSym hsym_var_src, unsigned char * dest) {

  TREE * tree=NULL;
  short          nL;
  unsigned short comp_len;
  short          offset;

  HANDLE h_var;
  unsigned char * data;
  unsigned short length;
  short type;

  CompErr error;
  
  if (hsym_var_src.folder==H_NULL)
    return COMP_ERR_NO_SRC_VAR;

  h_var=DerefSym(hsym_var_src)->handle;
  data=HLock(h_var);
  if (data==NULL)
    return COMP_ERR_MEM;

  length=*(unsigned short *)data;

  type=conv_type_TIOS_filelib(data[length+1]);

  error=study_zip(data+2,length,&tree,&nL,&comp_len,&offset,TRUE);

  if (error!=COMP_NO_ERR) {
  	HeapUnlock(h_var);
    return error;
  }
  
  error=mk_zip(data+2,length,dest,tree,nL,comp_len,offset,type,TRUE);

  HeapUnlock(h_var);

  return error;
}

