// C Source File
// Created 27/07/2003; 11:56:53

#include "mkcomplib.h"

/*===============================================================================================
== Ziplib compression of a variable in a temporary handle
=================================================================================================
== hsym_var_src : HSym structure of the var to compress
== error : pointer to return the error code
=================================================================================================
== return a handle with the compressed datas : the H_NULL handle if there is a error.
===============================================================================================*/

HANDLE zip_hsym_temp(HSym hsym_var_src, CompErr * error) {
  HANDLE h_var;
  unsigned char * data;
  unsigned short length=0;
  unsigned char type;

  TREE * tree=NULL;
  short          nL;
  unsigned short comp_len;
  short          offset;

  HANDLE h;
  unsigned char * dest;
  
  if (hsym_var_src.folder==H_NULL) {
    *error=COMP_ERR_NO_SRC_VAR;
    return H_NULL;
  }

  h_var=DerefSym(hsym_var_src)->handle;
  data=HLock(h_var);
  if (data==NULL) {
    *error=COMP_ERR_MEM;
    return H_NULL;
  }

  length=*(unsigned short *)data;

  type=conv_type_TIOS_filelib(data[length+1]);

  *error=study_zip(data+2,length,&tree,&nL,&comp_len,&offset,TRUE);

  if (*error!=COMP_NO_ERR) {
    HeapUnlock(h_var);
    return H_NULL;
  }  
  
  h=HeapAlloc(comp_len+2);
  if (h==H_NULL) {
    free(tree);
    HeapUnlock(h_var);
    *error=COMP_ERR_MEM;
    return H_NULL;
  }
  dest=HLock(h);
  
  *error=mk_zip(data+2,length,dest,tree,nL,comp_len,offset,type,TRUE);
  
  HeapUnlock(h_var);

  if (*error!=COMP_NO_ERR) {
    HeapFree(h);
    return H_NULL;
  }
  
  HeapUnlock(h);

  return h;
}
